module Main where

import System.Environment (getArgs, )
import qualified Data.ByteString.Lazy as B
import Data.List (groupBy, sort, )


groupEqualElems :: (Ord key, Ord elem) => [(elem, key)] -> [[key]]
groupEqualElems xs =
   map (map snd) (groupBy (\x y -> fst x == fst y) (sort xs))

{- | Only return sub-lists with more than one element. -}
clusterEqualElems :: (Ord key, Ord elem) => [(elem, key)] -> [[key]]
clusterEqualElems xs =
   filter (not . null . tail) (groupEqualElems xs)

clusterEqualFiles :: [FilePath] -> IO [[FilePath]]
clusterEqualFiles fileNames =
   do files <- mapM B.readFile fileNames
      return (clusterEqualElems (zip files fileNames))

-- output results in a quoted way that might be accessible to further shell scripts
main :: IO ()
main =
   mapM_ (putStrLn . unwords . map show) =<<
   clusterEqualFiles =<<
   getArgs
